package com.akamai.ampaudiodemo;

import android.app.Service;
import android.content.Intent;
import android.os.IBinder;
import android.widget.Toast;

import com.akamai.media.IPlayerEventsListener;
import com.akamai.media.VideoPlayerContainer;
import com.akamai.media.VideoPlayerView;
import com.akamai.media.elements.MediaResource;

public class AudioService extends Service implements IPlayerEventsListener {

    private final static String LICENSE = "hmYto8qpNkLvX0A8GUyvl0glGWPYxicNrSm-QfmVdiZVgl_BfjdJ6T1qwpyFowYKZ2YCe4VrLCf4IoywCkcKsA==";

    public VideoPlayerView mVideoView;
    public VideoPlayerContainer mVideoContainer;

    public static boolean isRunning = false;

    @Override
    public IBinder onBind(Intent arg0) {
        return null;
    }
    public void onCreate(){
        super.onCreate();
    }

    public int onStartCommand(android.content.Intent intent, int flags, int startId) {

        if(mVideoView != null && isRunning){
            mVideoView.stop();
        }

        String url = intent.getStringExtra("URL");

        Toast.makeText(getApplicationContext(), "Playing: " + url, Toast.LENGTH_SHORT).show();

        mVideoContainer = new VideoPlayerContainer(this);
        mVideoContainer.addVideoPlayerContainerCallback(new VideoPlayerContainer.VideoPlayerContainerCallback() {
            @Override
            public void onVideoPlayerCreated() {

            }

            @Override
            public void onResourceReady(MediaResource mediaResource) {
                mVideoContainer.setDefaultMode(VideoPlayerContainer.MODE_HARDWARE_ADVANCED);
                mVideoView =  mVideoContainer.getAudioPlayer();
                mVideoView.addEventsListener(AudioService.this);
                mVideoView.setLicense(LICENSE);
                mVideoView.playAudio(mediaResource);
                isRunning = true;
            }

            @Override
            public void onResourceError() {

            }
        });
        mVideoContainer.prepareResource(url);
        return Service.START_NOT_STICKY;
    }

    public void onDestroy(){

        super.onDestroy();
        if(mVideoView != null){
            mVideoView.stop();
            mVideoView.onDestroy();
        }
        isRunning = false;
    }

    @Override
    public boolean onPlayerEvent(int iInEventType) {
        return true;
    }

    @Override
    public boolean onPlayerExtendedEvent(int iInEventType, int arg1, int arg2) {
        return true;
    }
}
